
/**
  * @author THOMAS Alexandre
  * @author AUDRU Cedric
  */

import java.io.File;
import javax.swing.*;
import javax.swing.filechooser.*;

/** 
  * Cette classe permet simplement de creer un filtre pour le FileChooser correspondant aux fichier *.gan
  */
public class GanttFileFilter extends FileFilter {
    
    /** Pour savoir si le type de fichier est le bon. */
    public boolean accept(File f) {
        if (f.isDirectory()) {
            return true;
        }

        String extension = getExtension(f);
		if (extension != null && extension.equals("gan"))
			return true;
            
        return false;
    }
    
    /** Description du type de fichier */
    public String getDescription() {
        return "Fichier Projet Gantt";
    }

	/** Cette fonction retourne l'extention d'un fichier passe en parametre */	
	public static String getExtension(File f) {
        String ext = null;
        String s = f.getName();
        int i = s.lastIndexOf('.');

        if (i > 0 &&  i < s.length() - 1) {
            ext = s.substring(i+1).toLowerCase();
        }
        return ext;
    }
}
