
/**
  * @author THOMAS Alexandre
  * @author AUDRU Cedric
  */

import java.lang.String;


public abstract class GanttLanguage
{

	/** Retourne le nom de la langue. */
	abstract public String getLanguage();

	/** Titre de l'application. */
	abstract public String appliTitle();

	/**Retourne le nom du mois en fonction de son numero. */
	abstract public String getMonth (int m);

	/**Retourne le nom du jour de la semaine en fonction de son numero. */
	abstract public String getDay (int d);

	/**semaine */
	abstract public String week ();

	/** ok. */
	abstract public String getOk();

	/** Annuler. */
	abstract public String getCancel();

	/** Erreur. */
	abstract public String error();

	/** Attention. */
	abstract public String warning();

//////////////////////////////////////////////////////////////////////////

	/**menu : projet */
	abstract public String project ();

	/**menu : Nouveau projet */
	abstract public String newProject ();

	/**menu : Ouvrir projet */
	abstract public String openProject ();

	/**menu : Sauver projet */
	abstract public String saveProject ();

	/**menu : Sauver sous projet */
	abstract public String saveAsProject ();

	/**menu : imprimer le projet */
	abstract public String printProject ();

	/**menu : Quitter */
	abstract public String quit ();

//////////////////////////////////////////////////////////////////////////

	/**menu : tache */
	abstract public String task ();

	/**menu : Creer une nouvelle tache */
	abstract public String createTask ();

	/**menu : Supprimer la tache */
	abstract public String deleteTask ();

	/**menu : Proprietes de la tache */
	abstract public String propertiesTask ();

	/**menu : Notes de la tache */
	abstract public String notesTask ();

	/**menu : Monter la tache */
	abstract public String upTask ();

	/**menu : Descendre la tache */
	abstract public String downTask ();

//////////////////////////////////////////////////////////////////////////

	/**menu : langage */
	abstract public String language ();

//////////////////////////////////////////////////////////////////////////

	/**menu : aide */
	abstract public String help ();

	/**menu : manuel */
	abstract public String manual ();

	/**menu : page Web */
	abstract public String webPage ();

	/**menu : Le javadoc */
	abstract public String javadoc ();

	/**menu : a propos */
	abstract public String about ();

//////////////////////////////////////////////////////////////////////////

	/**menu :Reculer dans le temps */
	abstract public String backDate ();

	/**menu : Avancer dans le temps */
	abstract public String forwardDate ();

	/**menu : Zoomer */
	abstract public String zoomIn ();

	/**menu : Dezoomer */
	abstract public String zoomOut ();

//////////////////////////////////////////////////////////////////////////

	/**proprietes pour*/
	abstract public String propertiesFor ();

	/**Nouvelle tache*/
	abstract public String newTask ();

	/*Note pour*/
	abstract public String notesFor ();

	/**Choix d'une date*/
	abstract public String chooseDate ();

	/**Nom*/
	abstract public String name ();

	/**Tache mere*/
	abstract public String motherTask ();

	/**Aucune*/
	abstract public String none ();

	/**Date de debut*/
	abstract public String dateOfBegining ();

	/**Duree*/
	abstract public String length ();

	/**PointBilan*/
	abstract public String meetingPoint ();

	/**Dependances*/
	abstract public String depends ();

	/**Avancement.*/
	abstract public String advancement ();

	/**Ajouter la date du jour.*/
	abstract public String putDate ();

	/**Erreur quand on valide dans la boite de dialogue.*/
	abstract public String propertiesMsg (String taskName);

//////////////////////////////////////////////////////////////////////////

	/**Message 1 */
	abstract public String msg1();

	/**Message 2 */
	abstract public String msg2();

	/**Message 3 */
	abstract public String msg3();

	/**Message 4 */
	abstract public String msg4();

	/**Message 4 */
	abstract public String msg5();
}


