/***************************************************************************
                           GanttDialogExport.java  -  description
                             -------------------
    begin                : feb 2003
    copyright            : (C) 2003 by Thomas Alexandre
    email                : alexthomas@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


package net.sourceforge.ganttproject.gui;

import java.awt.BorderLayout;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.Box;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JPanel;
import net.sourceforge.ganttproject.GanttExportSettings;
import net.sourceforge.ganttproject.language.GanttLanguage;



/**
  * Dialog to edit the properties for export the calendar and print
  */
public class GanttDialogExport extends JDialog
{

	JCheckBox cbName, cbPercent, cbDepend;
	GanttExportSettings bool;

	/** Constructor */
	public GanttDialogExport(JFrame parent, GanttExportSettings sb, GanttLanguage language)
	{
		super(parent, language.getText("propertiesFor")+language.getText("export"),true);
	
		Box b1 = Box.createVerticalBox();
		
		
		bool = sb;
		
		
		cbName = new JCheckBox(language.getText("name"));
		cbName.setSelected(true);
		b1.add(cbName);
		
		cbPercent = new JCheckBox(language.getText("advancement"));
		cbPercent.setSelected(true);
		b1.add(cbPercent);
				
		cbDepend = new JCheckBox(language.getText("depends"));
		cbDepend.setSelected(true);				
		b1.add(cbDepend);
		
		
		getContentPane().add(b1,"Center");
		
		JPanel p = new JPanel();
		JButton ok = new JButton(language.getText("ok")/*, new ImageIcon(getClass().getResource("/icons/yes.gif"))*/);
		getRootPane().setDefaultButton(ok);
		p.add(ok);
		
		final JDialog theDialog = this;
		//Listener on the ok bouton 
		ok.addActionListener(new ActionListener()
		 	{	public void actionPerformed(ActionEvent evt)
				{
					bool.name = cbName.isSelected();
					bool.percent = cbPercent.isSelected();
					bool.depend = cbDepend.isSelected();
					bool.ok=true;
					setVisible (false); 					
				}
			});
			
		
		//cancel button
		JButton cancel = new JButton(language.getText("cancel")/*, new ImageIcon(getClass().getResource("/icons/no.gif"))*/);
		p.add(cancel);
		cancel.addActionListener(new ActionListener()
		 	{	public void actionPerformed(ActionEvent evt)
				{ 
					bool.ok=false;
					setVisible (false); 
				}
			});

		getContentPane().add(p,BorderLayout.SOUTH);

		pack();	
		
		setResizable(false);
		Point point = parent.getLocationOnScreen();
		int x = (int)point.getX() + parent.getWidth()/2;
		int y = (int)point.getY() + parent.getHeight()/2;
		setLocation(x-getWidth()/2, y-getHeight()/2);	
	}


	
}
