/***************************************************************************
                           GanttDialogOptions.java  -  description
                             -------------------
    begin                : sep 2003
    copyright            : (C) 2003 by Thomas Alexandre
    email                : alexthomas@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/



package net.sourceforge.ganttproject.gui;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JColorChooser;
import javax.swing.JDialog;

import net.sourceforge.ganttproject.GanttProject;
import net.sourceforge.ganttproject.document.HttpDocument;
import net.sourceforge.ganttproject.language.GanttLanguage;

/**
  * Dialog to edit options for ganttproject
  */
public class GanttDialogOptions 
	extends JDialog
	implements ActionListener {

	
	/** The option panel*/
	private OptionsPanel optionsPanel;
	
	/**true if the ok button was pressed */
    public boolean change = false;
	
	/** The main frame */
	GanttProject appli;
	
	/** Color chooser dialog */
    protected static JColorChooser colorChooser = new JColorChooser();
    private final UIConfiguration myUIConfiguration;


    /** Constructor */
	public GanttDialogOptions (GanttProject appli, UIConfiguration uiConfiguration) {
	
		super(appli,GanttProject.correctLabel(GanttLanguage.getInstance().getText("settings")),true);
	
		this.appli=appli;
        myUIConfiguration = uiConfiguration;

		optionsPanel = new OptionsPanel (this,appli);
		optionsPanel.addActionListener(this);
		Container cp = getContentPane();
		cp.add(optionsPanel, BorderLayout.CENTER);
		
		this.pack();
		setResizable(false);
    	Point point = appli.getLocationOnScreen();
	    int x = (int) point.getX() + appli.getWidth() / 2;
    	int y = (int) point.getY() + appli.getHeight() / 2;
	    setLocation(x - getWidth() / 2, y - getHeight() / 2);
	}


    UIConfiguration getUIConfiguration() {
        return myUIConfiguration;
    }

    /** Action to panel */
	public void actionPerformed(ActionEvent evt) {

		//Ok or cancel pressed
		if (evt.getSource()instanceof JButton) {
            JButton button = (JButton) evt.getSource();
            if (button.getName().equals("ok")) {
			
				//change project settings
				appli.projectName=optionsPanel.getProjectName();
				appli.description=optionsPanel.getProjectDescription();
				appli.organization=optionsPanel.getProjectOrganization();
			
				//change default color
				myUIConfiguration.setTaskColor(optionsPanel.getDefaultColor());
				//Change look'n'feel
				appli.changeLookAndFeel(optionsPanel.getLookAndFeel());
				//Automatic launch 
				appli.automatic = optionsPanel.getAutomatic();
				//Drag Option
				appli.dragTime = optionsPanel.getDragTime();
				//WebDAV Locking
				appli.lockDAVMinutes = optionsPanel.getLockDAVMinutes();
				HttpDocument.setLockDAVMinutes(appli.lockDAVMinutes);
				//set the xsl directory
				GanttProject.xslDir = optionsPanel.getXslDirectory();
				//set the xslfo file
				GanttProject.xslFo = optionsPanel.getXslFoFile();
				
				//Change for redLine
				myUIConfiguration.setRedlineOn(optionsPanel.getRedLine());
				
				/**Appli the new language*/
				optionsPanel.changeLanguage();
				
				//The new roles
				optionsPanel.setRoles();
				
			
                this.setVisible(false);
								dispose();
				change = true;
            } else if (button.getName().equals("cancel")) {
                this.setVisible(false);
								dispose();
            }

        }
	}
  
}










