/*
LICENSE:
                                                                 
   This program is free software; you can redistribute it and/or modify  
   it under the terms of the GNU General Public License as published by  
   the Free Software Foundation; either version 2 of the License, or     
   (at your option) any later version.                                   
                                                                         
   Copyright (C) 2004, GanttProject Development Team
 */
package net.sourceforge.ganttproject.gui;

import java.awt.*;

/**
 * Created by IntelliJ IDEA.
 * User: bard
 */
public class UIConfiguration {
    private final Font myMenuFont;
    private final Font myChartMainFont;
    private Color myTaskColor;
    private boolean isRedlineOn;

    public UIConfiguration(Font menuFont, Font chartMainFont, Color taskColor, boolean isRedlineOn) {
        myMenuFont = menuFont==null ? new Font("Dialog", Font.PLAIN, 12) : menuFont;
        myChartMainFont = chartMainFont==null ? new Font("SansSerif", Font.PLAIN, 9) : chartMainFont;
        this.isRedlineOn = isRedlineOn;
        setTaskColor(taskColor);
    }


    public Font getMenuFont(){
        return myMenuFont;
    }

    public Font getChartMainFont() {
        return myChartMainFont;
    }

    public Color getTaskColor() {
        return myTaskColor;
    }

    public void setTaskColor(Color myTaskColor) {
        this.myTaskColor = myTaskColor;
    }

    public boolean isRedlineOn() {
        return isRedlineOn;
    }

    public void setRedlineOn(boolean redlineOn) {
        isRedlineOn = redlineOn;
    }

}
