
/***************************************************************************
                           ResourceTagHandler.java  -  description
                             -------------------
    begin                : may 2003

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
package net.sourceforge.ganttproject.parser;

import net.sourceforge.ganttproject.resource.HumanResource;
import net.sourceforge.ganttproject.resource.ResourceManager;
import org.xml.sax.Attributes;

/** Class to parse the attibute of resources handler */
public class ResourceTagHandler implements TagHandler {
	public ResourceTagHandler(ResourceManager resourceManager) {
		myResourceManager = resourceManager;
                myResourceManager.clear(); //CleanUP the old stuff
	}

	/**
	 * @see net.sourceforge.ganttproject.parser.TagHandler#endElement(String, String, String)
	 */
	public void endElement(String namespaceURI, String sName, String qName) {

	}

	/**
	 * @see net.sourceforge.ganttproject.parser.TagHandler#startElement(String, String, String, Attributes)
	 */
	public void startElement(
		String namespaceURI,
		String sName,
		String qName,
		Attributes attrs) {

		if (qName.equals("resource")) {
            loadResource(attrs);            
		}
	}
	
	/** Las a resources */
    private void loadResource(Attributes atts) {
        HumanResource hr;
        
        try {        
            hr = (HumanResource)getResourceManager().create(
                atts.getValue("name"),
                Integer.parseInt(atts.getValue("id")));
        }
        catch (NumberFormatException e) {
            System.out.println ("ERROR in parsing XML File id is not numeric: "+e.toString());
            return;
        }            
        
        hr.setMail(atts.getValue("contacts"));
	hr.setPhone(atts.getValue("phone"));
        try {
            hr.setFunction(Integer.parseInt(atts.getValue("function")));
        }
        catch (NumberFormatException e) {
            System.out.println ("ERROR in parsing XML File function id is not numeric: "+e.toString());
        }

        try {
            hr.setId(Integer.parseInt(atts.getValue("id")));
        }
        catch (NumberFormatException e) {
            System.out.println ("ERROR in parsing XML File id is not numeric: "+e.toString());
        }
    }

    private ResourceManager getResourceManager() {
        return myResourceManager;
    }
    private final ResourceManager myResourceManager;
	//private GanttPeoplePanel myPeople;
}
