
/***************************************************************************
                           ResourceTagHandler.java  -  description
                             -------------------
    begin                : may 2003

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
package net.sourceforge.ganttproject.parser;

import net.sourceforge.ganttproject.roles.*;
import org.xml.sax.Attributes;

/** Class to parse the attibute of resources handler */
public class RoleTagHandler implements TagHandler {
	public RoleTagHandler(RoleManager roleManager) {
		myRoleManager = roleManager;
        myRoleManager.clear(); //CleanUP the old stuff
	}

	/**
	 * @see net.sourceforge.ganttproject.parser.TagHandler#endElement(String, String, String)
	 */
	public void endElement(String namespaceURI, String sName, String qName) {

	}

	/**
	 * @see net.sourceforge.ganttproject.parser.TagHandler#startElement(String, String, String, Attributes)
	 */
	public void startElement(
		String namespaceURI,
		String sName,
		String qName,
		Attributes attrs) {

		if (qName.equals("role")) {
            loadRoles(attrs);            
		}
	}
	
	/** Las a role */
    private void loadRoles(Attributes atts) {
        String roleName=atts.getValue("name");
		int roleID;
		
        try {        
            roleID = Integer.parseInt(atts.getValue("id"));
        }
        catch (NumberFormatException e) {
            System.out.println ("ERROR in parsing XML File id is not numeric: "+e.toString());
            return;
        }            		
		myRoleManager.add(roleID, roleName);
    }

    private RoleManager getRoleManager() {
        return myRoleManager;
    }
    private final RoleManager myRoleManager;
}
