

package net.sourceforge.ganttproject.roles;

import java.util.ArrayList;
import java.util.*;

import net.sourceforge.ganttproject.language.GanttLanguage;

/**
 * @author athomas
 *
 */
public class RoleManagerImpl implements RoleManager {
	String [] defaultRoles;
    private ArrayList myDefaultRoles = new ArrayList();
    private final ArrayList myProjectLevelRoles = new ArrayList();

    public RoleManagerImpl () {
		GanttLanguage language=GanttLanguage.getInstance();
        myDefaultRoles.add(newRole(0, language.getText("resUndefined")));
        myDefaultRoles.add(newRole(0, language.getText("resProjectManager")));
        myDefaultRoles.add(newRole(0, language.getText("resDeveloper")));
        myDefaultRoles.add(newRole(0, language.getText("resDocWriter")));
        myDefaultRoles.add(newRole(0, language.getText("resTester")));
        myDefaultRoles.add(newRole(0, language.getText("resGraphicDesigner")));
        myDefaultRoles.add(newRole(0, language.getText("resDocTranslator")));
        myDefaultRoles.add(newRole(0, language.getText("resPackager")));
        myDefaultRoles.add(newRole(0, language.getText("resAnalysis")));
        myDefaultRoles.add(newRole(0, language.getText("resWebDesigner")));
        myDefaultRoles.add(newRole(0, language.getText("resNoSpecificRole")));
	}

    private Role newRole(int i, String name) {
        return new RoleImpl(i, name);
    }

    public void clear(){
		myProjectLevelRoles.clear();
	}
    
	public String [] getRoleNames() {
//		String []res = new String [DEFAULT_ROLES_NUMBER+myId2Role.size()];
//		int i;
//		for(i=0;i<DEFAULT_ROLES_NUMBER;i++) res[i] = defaultRoles[i];
//
//		int [] key = new int [myId2Role.size()];
//		int j=0;
//		for(Enumeration e = Collections.enumeration(myId2Role.keySet()); e.hasMoreElements() ; j++)
//			key[j]=((Integer)e.nextElement()).hashCode();
//		Arrays.sort(key);
//
//		for(j=0;j<key.length;j++,i++)
//			res[i]=(String)(myId2Role.get(new Integer(key[j])));
//
//		return res;
        ArrayList result = new ArrayList(myDefaultRoles.size()+myProjectLevelRoles.size());
        for (int i=0; i<myDefaultRoles.size(); i++) {
            result.add( ((Role)myDefaultRoles.get(i)).getName() );
        }
        for (int i=0; i<myProjectLevelRoles.size(); i++) {
            result.add( ((Role)myProjectLevelRoles.get(i)).getName() );
        }
        return (String[]) result.toArray(new String[result.size()]);
	}

    //public String [] getRolesShort();
    public Role[] getProjectLevelRoles() {
        return (Role[])myProjectLevelRoles.toArray(new Role[0]);
    }
	
	public void setRoles (Hashtable roles) {
		//myId2Role=new LinkedHashMap(roles);
        myProjectLevelRoles.clear();
        for (Iterator i = roles.entrySet().iterator(); i.hasNext(); ) {
            Map.Entry next = (Map.Entry)i.next();
            Integer id = (Integer)next.getKey();
            String name = (String)next.getValue();
            add(id.intValue(), name);
        }
	}
	
//	public String getRole (int ID) {
//		if(ID<DEFAULT_ROLES_NUMBER) return defaultRoles[ID];
//		/*else*/  return (String)myId2Role.get(new Integer(ID));
//	}
	
	/** Return the number of roles for the project, exept the default roles*/
	public int nbOfRoles(){
		return myProjectLevelRoles.size();
	}
	
	/** Add a role on the list */
	public void add (int ID, String role){
		myProjectLevelRoles.add(newRole(ID, role));
	}
	

	
	//Hashmap contains ID of the roles and the string for the role
	//But not contains the other roles that are allready select and translate for the differents languages.
    //private HashMap myId2Role = new LinkedHashMap();
}
