/*
 * Created on 26.03.2005
 */
package net.sourceforge.ganttproject.action;

import java.awt.Toolkit;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.Icon;
import javax.swing.ImageIcon;

import net.sourceforge.ganttproject.language.GanttLanguage;
import net.sourceforge.ganttproject.language.GanttLanguage.Event;

/**
 * @author bard
 */
public abstract class GPAction extends AbstractAction implements
        RolloverAction, GanttLanguage.Listener {
    public static final int MENU_MASK = Toolkit.getDefaultToolkit()
            .getMenuShortcutKeyMask();

    protected boolean iconVisible = true;
    private Icon myIcon = null;

    protected GPAction() {
        this(null, null);
    }

    protected GPAction(String name, String iconSize) {
        super(name);
        setIconSize(iconSize);
        String localizedName = getLocalizedName();
        if (localizedName == null) {
            localizedName = name;
        }
        if (localizedName != null) {
            putValue(Action.NAME, localizedName);
        }
        GanttLanguage.getInstance().addListener(this);
    }

    public Icon getIconOnMouseOver() {
        return (Icon) getValue(Action.SMALL_ICON);
    }

    public void setIconSize(String iconSize) {
        Icon icon = createIcon(iconSize);
        if (icon != null) {
            putValue(Action.SMALL_ICON, icon);
            myIcon = icon;
        }
    }

    protected Icon createIcon(String iconSize) {
        if (iconSize == null) {
            return null;
        }
        return iconVisible ? new ImageIcon(getClass().getResource(
                getIconFileDirectory() + "/" + getIconFilePrefix() + iconSize
                        + ".gif")) : null;
    }

    protected String getIconFileDirectory() {
        return "/icons";
    }

    protected String getLocalizedName() {
        return "";
    }

    protected abstract String getIconFilePrefix();

    public void setIconVisible(boolean isVisible) {
        iconVisible = isVisible;
        putValue(Action.SMALL_ICON, iconVisible ? myIcon : null);
    }

    public void isIconVisible(boolean isNull) {
        setIconVisible(isNull);
    }

    public void languageChanged(Event event) {
        String localizedName = getLocalizedName();
        if (localizedName != null) {
            putValue(Action.NAME, localizedName);
        }
    }
}
