/*
 * GanttDialogPerson.java
 *
 * Created on 5. September 2003, 14:05
 */

package net.sourceforge.ganttproject.gui;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Frame;

import javax.swing.DefaultListModel;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTextField;
import javax.swing.border.EtchedBorder;
import javax.swing.border.TitledBorder;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import net.sourceforge.ganttproject.GanttCalendar;
import net.sourceforge.ganttproject.GanttProject;
import net.sourceforge.ganttproject.Mediator;
import net.sourceforge.ganttproject.calendar.GanttDaysOff;
import net.sourceforge.ganttproject.language.GanttLanguage;
import net.sourceforge.ganttproject.resource.HumanResource;
import net.sourceforge.ganttproject.roles.Role;
import net.sourceforge.ganttproject.roles.RoleManager;

/**
 * @author barmeier
 */
public class GanttDialogPerson extends javax.swing.JDialog {
    private boolean change;

    private HumanResource person;

    /** The language use */
    private GanttLanguage language = GanttLanguage.getInstance();

    private GanttProject appli;

    private JTabbedPane tabbedPane = new JTabbedPane();

    /** Creates new form GanttDialogPerson */
    public GanttDialogPerson(Frame parent, GanttLanguage language,
            HumanResource person) {
        super(parent, GanttProject.correctLabel(language.getText("human")),
                true);
        this.person = person;
        appli = (GanttProject) parent;
        initComponents();
        DialogAligner.center(this, parent);
        applyComponentOrientation(language.getComponentOrientation());
    }

    public boolean result() {
        return change;
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    private void initComponents() {// GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        jPanel3 = new javax.swing.JPanel();
        jPanel2 = new javax.swing.JPanel();
        unitsPerDay = new javax.swing.JLabel();
        phoneField1 = new javax.swing.JTextField();
        efficency = new javax.swing.JLabel();
        emailInput1 = new javax.swing.JTextField();
        resourceData = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        // String []sCombo0 = RoleManager.Access.getInstance().getRoleNames();
        Role[] roles = RoleManager.Access.getInstance().getEnabledRoles();
        System.err.println("[GanttDialogPerson] initComponents(): roles="
                + java.util.Arrays.asList(roles) + " selected role="
                + person.getRole());

        functionList = new javax.swing.JComboBox(roles);
        functionList.setRenderer(new GanttCellListRenderer());
        functionList.setSelectedItem(person.getRole());
        name = new javax.swing.JLabel();
        nameField = new javax.swing.JTextField();
        nameField.setText(person.getName());
        phone = new javax.swing.JLabel();
        phoneField = new javax.swing.JTextField();
        phoneField.setText(person.getPhone());
        email = new javax.swing.JLabel();
        emailField = new javax.swing.JTextField();
        emailField.setText(person.getMail());
        function = new javax.swing.JLabel();
        persTitle = new javax.swing.JLabel();
        okButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();
        jPanel4 = new javax.swing.JPanel();

        getContentPane().setLayout(new java.awt.GridBagLayout());

        setResizable(false);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        jPanel3.setLayout(new java.awt.GridBagLayout());

        jPanel3.setPreferredSize(new java.awt.Dimension(520, 160));
        jPanel2.setLayout(new java.awt.GridBagLayout());

        jPanel2.setBorder(new TitledBorder(
                new javax.swing.border.EtchedBorder(), language
                        .getText("resourceData")));
        jPanel2.setPreferredSize(new java.awt.Dimension(237, 108));
        unitsPerDay.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        unitsPerDay.setText("Maximale Einheiten pro Tag:");
        unitsPerDay.setText(language.getText("unitsPerDay"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(0, 60, 0, 0);
        jPanel2.add(unitsPerDay, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 0.2;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        jPanel2.add(phoneField1, gridBagConstraints);

        efficency.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        efficency.setText("Effizienz:");
        efficency.setText(language.getText("efficency"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 60, 10, 0);
        jPanel2.add(efficency, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 0.8;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 10, 5);
        jPanel2.add(emailInput1, gridBagConstraints);

        /*
         * resourceData.setFont(new java.awt.Font("Dialog", 3, 18));
         * resourceData.setText("Resourcedaten");
         * resourceData.setVerticalAlignment(javax.swing.SwingConstants.TOP);
         * resourceData.setText(language.getText("resourceData"));
         * gridBagConstraints = new java.awt.GridBagConstraints();
         * gridBagConstraints.gridx = 0; gridBagConstraints.gridy = 0;
         * gridBagConstraints.gridwidth = 5; gridBagConstraints.ipady = 10;
         * gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
         * gridBagConstraints.insets = new java.awt.Insets(0, 10, 0, 0);
         * jPanel2.add(resourceData, gridBagConstraints);
         */

        /*
         * gridBagConstraints = new java.awt.GridBagConstraints();
         * gridBagConstraints.gridx = 0; gridBagConstraints.gridy = 1;
         * gridBagConstraints.gridwidth = 5; gridBagConstraints.fill =
         * java.awt.GridBagConstraints.BOTH; gridBagConstraints.anchor =
         * java.awt.GridBagConstraints.SOUTH; gridBagConstraints.weightx = 1.0;
         * gridBagConstraints.weighty = 0.9; gridBagConstraints.insets = new
         * java.awt.Insets(10, 10, 5, 10); jPanel3.add(jPanel2,
         * gridBagConstraints);
         */

        jPanel1.setLayout(new java.awt.GridBagLayout());

        jPanel1.setBorder(new TitledBorder(
                new javax.swing.border.EtchedBorder(), language
                        .getText("personData")));
        jPanel1.setPreferredSize(new java.awt.Dimension(208, 133));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 10, 0);
        jPanel1.add(functionList, gridBagConstraints);

        name.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        name.setText("Name: ");
        name.setText(language.getText("name"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(0, 60, 0, 0);
        jPanel1.add(name, gridBagConstraints);

        nameField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                nameFieldActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 10;
        gridBagConstraints.weightx = 0.8;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 5);
        jPanel1.add(nameField, gridBagConstraints);

        phone.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        phone.setText("Phone:");
        phone.setText(language.getText("colPhone"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 0);
        jPanel1.add(phone, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 0.2;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        jPanel1.add(phoneField, gridBagConstraints);

        email.setText("EMail:");
        email.setText(language.getText("colMail"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 2;
        jPanel1.add(email, gridBagConstraints);

        emailField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                emailFieldActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 5;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 0.8;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 5);
        jPanel1.add(emailField, gridBagConstraints);

        function.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        function.setText("Funktion: ");
        function.setText(language.getText("colRole"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 5, 0);
        jPanel1.add(function, gridBagConstraints);

        /*
         * persTitle.setFont(new java.awt.Font("Dialog", 3, 18));
         * persTitle.setText("Personendaten");
         * persTitle.setVerticalAlignment(javax.swing.SwingConstants.TOP);
         * persTitle.setText(language.getText("personData")); gridBagConstraints =
         * new java.awt.GridBagConstraints(); gridBagConstraints.gridx = 0;
         * gridBagConstraints.gridy = 0; gridBagConstraints.gridwidth = 2;
         * gridBagConstraints.ipady = 10; gridBagConstraints.anchor =
         * java.awt.GridBagConstraints.NORTHWEST; gridBagConstraints.insets =
         * new java.awt.Insets(0, 10, 0, 0); jPanel1.add(persTitle,
         * gridBagConstraints);
         */

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 0.1;
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 5, 10);
        jPanel3.add(jPanel1, gridBagConstraints);

        okButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        okButton.setPreferredSize(new java.awt.Dimension(96, 26));
        okButton.setText(language.getText("ok"));
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButtonActionPerformed(evt);
            }
        });
        getRootPane().setDefaultButton(okButton);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 10, 10);
        JPanel southPanel = new JPanel(new FlowLayout(FlowLayout.TRAILING, 50,
                10));

        southPanel.add(okButton);

        cancelButton.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        cancelButton.setText(language.getText("cancel"));
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 10, 10);

        southPanel.add(cancelButton);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        jPanel3.add(jPanel4, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 5;
        gridBagConstraints.gridheight = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        // getContentPane().add(jPanel3, gridBagConstraints);
        tabbedPane.addTab(language.getText("general"), new ImageIcon(getClass()
                .getResource("/icons/properties_16.gif")), jPanel3);
        tabbedPane.addTab(language.getText("daysOff"), new ImageIcon(getClass()
                .getResource("/icons/holidays_16.gif")),
                constructDaysOffPanel());

        getContentPane().setLayout(new BorderLayout());
        getContentPane().add(tabbedPane);
        getContentPane().add(southPanel, BorderLayout.SOUTH);
        pack();
        nameField.requestFocusInWindow();
    }// GEN-END:initComponents

    private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {// GEN-FIRST:event_okButtonActionPerformed
        if ((!person.getName().equals(nameField.getText()))
                || (!person.getMail().equals(emailField.getText()))
                || (!person.getPhone().equals(phoneField.getText()))
                || (!person.getRole().equals(
                        (Role) functionList.getSelectedItem()))
                || (daysOffChanged)) {
            if (person.getId() != -1) {// person ID is -1 when it is new one
                // i.e. before the Person dialog is
                // closed
                Mediator.getUndoManager().undoableEdit(
                        "Resource properties changed", new Runnable() {
                            public void run() {
                                person.setName(nameField.getText());
                                person.setMail(emailField.getText());
                                person.setPhone(phoneField.getText());
                                person.setRole((Role) functionList
                                        .getSelectedItem());
                                person.setDaysOff(daysOffList);
                                appli.paint(appli.getGraphics());// to
                                // display
                                // the days
                                // off on
                                // the
                                // resource
                                // pane
                            }
                        });

            }

            else {
                // the GanttDialog is called when a new human is created
                person.setName(nameField.getText());
                person.setMail(emailField.getText());
                person.setPhone(phoneField.getText());
                person.setRole((Role) functionList.getSelectedItem());
                person.setDaysOff(daysOffList);
            }
        }
        change = true;
        closeDialog(null);
    }// GEN-LAST:event_okButtonActionPerformed

    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {// GEN-FIRST:event_cancelButtonActionPerformed
        closeDialog(null);
    }// GEN-LAST:event_cancelButtonActionPerformed

    private void nameFieldActionPerformed(java.awt.event.ActionEvent evt) {// GEN-FIRST:event_nameFieldActionPerformed
        // Add your handling code here:
    }// GEN-LAST:event_nameFieldActionPerformed

    private void emailFieldActionPerformed(java.awt.event.ActionEvent evt) {// GEN-FIRST:event_emailFieldActionPerformed
        // Add your handling code here:
    }// GEN-LAST:event_emailFieldActionPerformed

    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {// GEN-FIRST:event_closeDialog
        setVisible(false);
        dispose();
    }// GEN-LAST:event_closeDialog

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton cancelButton;

    private javax.swing.JLabel efficency;

    private javax.swing.JLabel email;

    private javax.swing.JTextField emailField;

    private javax.swing.JTextField emailInput1;

    private javax.swing.JLabel function;

    private javax.swing.JComboBox functionList;

    private javax.swing.JPanel jPanel1;

    private javax.swing.JPanel jPanel2;

    private javax.swing.JPanel jPanel3;

    private javax.swing.JPanel jPanel4;

    private javax.swing.JLabel name;

    private javax.swing.JTextField nameField;

    private javax.swing.JButton okButton;

    private javax.swing.JLabel persTitle;

    private javax.swing.JLabel phone;

    private javax.swing.JTextField phoneField;

    private javax.swing.JTextField phoneField1;

    private javax.swing.JLabel resourceData;

    private javax.swing.JLabel unitsPerDay;

    // End of variables declaration//GEN-END:variables

    private JTextField startDateField1, finishDateField1;

    private JButton addButton, deleteButton;

    private GanttCalendar start, finish;

    private DefaultListModel daysOffList;

    private boolean daysOffChanged = false;

    private JList list;

    public JPanel constructDaysOffPanel() {
        // setLayout(new BorderLayout());
        JPanel daysOffPanel = new JPanel();
        daysOffPanel.setLayout(new BorderLayout());
        daysOffPanel.add(addDaysOffPanel(), BorderLayout.NORTH);
        daysOffPanel.add(deleteDaysOffPanel(), BorderLayout.SOUTH);
        return daysOffPanel;
    }

    public JPanel addDaysOffPanel() {
        JLabel startDateLabel1, finishDateLabel1;
        JButton startDateButton1, finishDateButton1;
        JPanel addDaysOffPanel;

        FlowLayout flowL = new FlowLayout(FlowLayout.LEFT, 10, 10);

        addButton = new JButton(language.getText("add"));
        addButton.setName("add");
        addButton.setEnabled(false);
        addButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addButtonActionPerformed(evt);
            }
        });

        startDateLabel1 = new JLabel(language.getText("dateOfBegining") + ":");
        startDateField1 = new JTextField(12);
        startDateField1.setEditable(false);
        finishDateLabel1 = new JLabel(language.getText("dateOfEnd") + ":");

        finishDateField1 = new JTextField(12);
        finishDateField1.setEditable(false);

        ImageIcon icon = new ImageIcon(getClass().getResource(
                "/icons/calendar_16.gif"));

        startDateButton1 = new TestGanttRolloverButton(icon);
        startDateButton1.setName("start");
        startDateButton1.setToolTipText(GanttProject.getToolTip(language
                .getText("chooseDate")));
        startDateButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                dateButtonActionPerformed(evt, 1);
            }
        });
        finishDateButton1 = new TestGanttRolloverButton(icon);
        finishDateButton1.setName("finish");
        finishDateButton1.setToolTipText(GanttProject.getToolTip(language
                .getText("chooseDate")));
        finishDateButton1
                .addActionListener(new java.awt.event.ActionListener() {
                    public void actionPerformed(java.awt.event.ActionEvent evt) {
                        dateButtonActionPerformed(evt, 2);
                    }
                });
        addDaysOffPanel = new JPanel(flowL);
        addDaysOffPanel.setBorder(new TitledBorder(new EtchedBorder(), language
                .getText("add")));
        addDaysOffPanel.add(startDateLabel1);
        addDaysOffPanel.add(startDateField1);
        addDaysOffPanel.add(startDateButton1);
        addDaysOffPanel.add(finishDateLabel1);
        addDaysOffPanel.add(finishDateField1);
        addDaysOffPanel.add(finishDateButton1);
        addDaysOffPanel.add(addButton);
        return addDaysOffPanel;
    }

    public JPanel deleteDaysOffPanel() {
        daysOffList = new DefaultListModel();
        if (person.getDaysOff() != null)
            for (int i = 0; i < person.getDaysOff().size(); i++)
                daysOffList.addElement(person.getDaysOff().getElementAt(i));
        list = new JList(daysOffList);
        list.setName("list");
        list.addListSelectionListener(new ListSelectionListener() {
            public void valueChanged(ListSelectionEvent arg0) {
                selectedDaysOff(arg0);
            }
        });
        JScrollPane scrollPane = new JScrollPane(list);
        scrollPane.setPreferredSize(new Dimension(240, 50));
        deleteButton = new JButton(language.getText("delete"));
        deleteButton.setName("delete");
        deleteButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                deleteButtonActionPerformed(evt);
            }
        });
        if (daysOffList.size() == 0)
            deleteButton.setEnabled(false);
        JPanel deleteDaysOffPanel = new JPanel(new FlowLayout(
                FlowLayout.TRAILING, 30, 10));
        deleteDaysOffPanel.add(scrollPane);
        deleteDaysOffPanel.add(deleteButton);
        deleteDaysOffPanel.setBorder(new TitledBorder(new EtchedBorder(),
                language.getText("delete")));
        return deleteDaysOffPanel;
    }

    private void dateButtonActionPerformed(java.awt.event.ActionEvent evt,
            int type) {
        GanttCalendar date = new GanttCalendar();
        GanttDialogDate dd;
        if ((type == 1) && (start != null))
            date = start.Clone();
        else if ((type == 2) && (finish != null))
            date = finish.Clone();
        else if ((type == 2) && (start != null))
            date = start.newAdd(1);
        dd = new GanttDialogDate(this, date, false);

        dd.show();

        if (type == 1) {
            start = dd.getDate();
            startDateField1.setText(dd.getDate().toString());
        } else if (type == 2) {
            finish = dd.getDate();
            finishDateField1.setText(dd.getDate().toString());
        }
        if ((!addButton.isEnabled()) && (!startDateField1.getText().equals(""))
                && (!finishDateField1.getText().equals("")))
            addButton.setEnabled(true);
    }

    private void addButtonActionPerformed(java.awt.event.ActionEvent evt) {
        if (!start.after(finish)) {
            GanttDaysOff gdo = new GanttDaysOff(start, finish);
            boolean isUnique = true;
            for (int i = 0; i < daysOffList.size(); i++)
                if (((GanttDaysOff) daysOffList.getElementAt(i)).equals(gdo)) {
                    isUnique = false;
                    break;
                }
            if (isUnique) {
                daysOffList.addElement(gdo);
                if (!deleteButton.isEnabled())
                    deleteButton.setEnabled(true);
                daysOffChanged = true;
                finish = null;
            }
        } else {
            GanttDialogInfo gdi = new GanttDialogInfo(appli,
                    GanttDialogInfo.ERROR, GanttDialogInfo.YES_OPTION, language
                            .getText("msg24"), language.getText("error"));
            gdi.show();
        }
    }

    private void deleteButtonActionPerformed(java.awt.event.ActionEvent evt) {
        Object[] objects = list.getSelectedValues();
        if ((objects.length > 0) && (!daysOffChanged))
            daysOffChanged = true;
        for (int i = 0; i < objects.length; i++) {
            daysOffList.removeElement(objects[i]);
        }
        if (daysOffList.size() == 0)
            deleteButton.setEnabled(false);
    }

    private void selectedDaysOff(ListSelectionEvent arg0) {
        if (list.getSelectedIndex() >= 0) {
            GanttDaysOff daysOff = (GanttDaysOff) list.getSelectedValue();
            start = daysOff.getStart();
            startDateField1.setText(start.toString());
            finish = daysOff.getFinish();
            finishDateField1.setText(finish.toString());
        }
    }
}
