/*
 * Created on 26.02.2005
 */
package net.sourceforge.ganttproject.gui;

import java.awt.Component;

import javax.swing.Action;

import net.sourceforge.ganttproject.GanttTree2;
import net.sourceforge.ganttproject.chart.Chart;
import net.sourceforge.ganttproject.chart.ChartViewState;
import net.sourceforge.ganttproject.gui.scrolling.ScrollingManager;
import net.sourceforge.ganttproject.gui.zoom.ZoomManager;

/**
 * @author bard
 */
public interface UIFacade {
    public static final int GANTT_INDEX = 0;

    public static final int RESOURCES_INDEX = 1;

    ScrollingManager getScrollingManager();

    ChartViewState getGanttChartViewState();

    ZoomManager getZoomManager();

    boolean showConfirmationDialog(String message, String title);

    void showPopupMenu(Component invoker, Action[] actions, int x, int y);

    void showDialog(Component content, Action[] buttonActions);

    void repaint2();
    
    void recalculateCriticalPath();

    void setStatusText(String text);

    void showErrorDialog(String errorMessage);

    void showErrorDialog(Exception e);

    Chart getGanttChart();

    Chart getResourceChart();

    Chart getActiveChart();

    /**
     * Returns the index of the displayed tab.
     * 
     * @return the index of the displayed tab.
     */
    int getViewIndex();

    void setViewIndex(int viewIndex);

    int getGanttDividerLocation();

    void setGanttDividerLocation(int location);

    int getResourceDividerLocation();

    void setResourceDividerLocation(int location);

    void refresh();
    
    GanttTree2 getTree();
}
