package net.sourceforge.ganttproject.gui.options.model;

public abstract class GPAbstractOption implements GPOption {
    private final String myID;

    protected boolean isLocked;

    protected GPAbstractOption(String id) {
        myID = id;
    }

    public String getID() {
        return myID;
    }

    public void lock() {
        if (isLocked) {
            throw new IllegalStateException("Already locked");
        }
        isLocked = true;
    }

    public void commit() {
        if (!isLocked()) {
            throw new IllegalStateException("Can't commit not locked option");
        }
        setLocked(false);

    }

    public void rollback() {
        if (!isLocked()) {
            throw new IllegalStateException("Can't rollback not locked option");
        }
        setLocked(false);
    }

    protected boolean isLocked() {
        return isLocked;
    }

    protected void setLocked(boolean isLocked) {
        this.isLocked = isLocked;
    }

}
