/*
 * Created on 01.05.2005
 */
package net.sourceforge.ganttproject.importer;

import java.awt.BorderLayout;
import java.awt.Component;
import java.io.File;

import javax.swing.Box;
import javax.swing.JLabel;
import javax.swing.JPanel;

import net.sourceforge.ganttproject.filter.ExtensionBasedFileFilter;
import net.sourceforge.ganttproject.gui.TextFieldAndFileChooserComponent;
import net.sourceforge.ganttproject.gui.projectwizard.WizardPage;
import net.sourceforge.ganttproject.importer.ImportFileWizardImpl.State;
import net.sourceforge.ganttproject.language.GanttLanguage;

/**
 * @author bard
 */
class FileChooserPage implements WizardPage {

    private State myState;

    private TextFieldAndFileChooserComponent myChooser;

    public FileChooserPage(State state) {
        myState = state;
    }

    public String getTitle() {
        return GanttLanguage.getInstance().getText("importerFileChooserPageTitle");
    }

    public Component getComponent() {
        JPanel result = new JPanel(new BorderLayout());
        Box innerBox = Box.createHorizontalBox();
        innerBox.add(new JLabel(GanttLanguage.getInstance().getText("file")+":"));
        innerBox.add(Box.createHorizontalStrut(2));
        myChooser = new TextFieldAndFileChooserComponent(innerBox,
        		getTitle()) {
            protected void onFileChosen(File file) {
                super.onFileChosen(file);
                myState.setFile(file);
            }
        };
        innerBox.add(myChooser.getComponent());
        result.add(innerBox, BorderLayout.NORTH);
        return result;
    }

    public void setActive(boolean b) {
        if (b == false) {
            myState.setFile(myChooser.getFile());
        } else {
            myChooser.setFileFilter(new ExtensionBasedFileFilter(
                    myState.myImporter.getFileNamePattern(), myState.myImporter
                            .getFileTypeDescription()));
            if (myState.getFile() == null) {
                myChooser.showFileChooser();
            } else {
                myChooser.setFile(myState.getFile());
            }
        }
    }

}
