package net.sourceforge.ganttproject.importer;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import net.sourceforge.ganttproject.GanttProject;
import net.sourceforge.ganttproject.gui.GanttDialogInfo;

public class ImporterBase {
    
    private List myPreImporterProcessors = new ArrayList();
    
    protected boolean acceptImport(GanttProject ganttProject) {
        boolean bMerge = false;
        boolean accept = false;

        if (ganttProject.projectDocument != null
                || ganttProject.askForSave == true) {
            GanttDialogInfo gdi = new GanttDialogInfo(ganttProject,
                    GanttDialogInfo.QUESTION, GanttDialogInfo.YES_NO_OPTION,
                    ganttProject.getLanguage().getText("msg17"), ganttProject
                            .getLanguage().getText("question"));
            gdi.show();
            bMerge = (gdi.res == GanttDialogInfo.YES);
            accept = true;
        }
        else if(ganttProject.projectDocument == null)
            accept=true;

        if (!bMerge) {
            if (ganttProject.checkCurrentProject()) {
                ganttProject.closeProject(true);
            }
        }

        return accept;
    }

    public String getFileTypeDescription() {
        return null;
    }

    public String getFileNamePattern() {
        return null;
    }

    public void addPreImporterProcessor(PreImporterProcessor preImporterProcessor){
        myPreImporterProcessors.add(preImporterProcessor);
    }
    
    protected void run(){
        Iterator it = myPreImporterProcessors.iterator();
        while(it.hasNext()){
            ((PreImporterProcessor)it.next()).run();
        }
    }

}
