/*
 * Created on 17.05.2005
 */
package org.ganttproject.impex.htmlpdf;

import java.io.File;

import net.sourceforge.ganttproject.IGanttProject;
import net.sourceforge.ganttproject.chart.Chart;
import net.sourceforge.ganttproject.export.Exporter;
import net.sourceforge.ganttproject.gui.UIFacade;
import net.sourceforge.ganttproject.gui.options.model.GPOption;
import net.sourceforge.ganttproject.gui.options.model.GPOptionGroup;
import net.sourceforge.ganttproject.language.GanttLanguage;

public class ExporterToHTML implements Exporter {
    private AdvancedOptionGroup myAdvancedOptions = new AdvancedOptionGroup(new GPOption[0]);
    private IGanttProject myProject;
    private UIFacade myUIFacade;
    private Chart myGanttChart;
    public String getFileTypeDescription() {
        return GanttLanguage.getInstance().getText("impex.html.description");
    }

    public GPOptionGroup getOptions() {
        return new GPOptionGroup("exporter.html", new GPOption[] {myAdvancedOptions});
    }

    public GPOptionGroup[] getSecondaryOptions() {
        return getGanttChart().getOptionGroups();
    }    
    
    private Chart getGanttChart() {
        return myGanttChart;
    }

    public String getFileNamePattern() {
        return "html";
    }

    public void setContext(IGanttProject project, UIFacade uiFacade) {
        myGanttChart = uiFacade.getGanttChart().createCopy();
    }
    
    public File[] run(File outputFile)
            throws Exception {
        // TODO Auto-generated method stub
        return null;
    }

    public String proposeFileExtension() {
        return "html";
    }

    private class AdvancedOptionGroup extends GPOptionGroup implements GPOption {
        public AdvancedOptionGroup(GPOption[] options) {
            super("exporter.html.advanced", options);
        }
        
    }

    public String[] getFileExtensions() {
        String s [] = {"html"};
        return s;
    }

}
